<?php
/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

/**
 * Used in creating options for Yes|No config value selection
 *
 */

namespace FiloBlu\Newsletter\Model\ThankYou\Source;

use FiloBlu\Newsletter\Model\ThankYou;
use Magento\Framework\Option\ArrayInterface;

class PageList implements ArrayInterface
{
    protected $thankYouPage;

    /**
     * PageList constructor.
     * @param ThankYou $thankYouPage
     */
    public function __construct(ThankYou $thankYouPage)
    {
        $this->thankYouPage = $thankYouPage;
    }


    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $options[] = ['label' => 'None', 'value' => ''];
        $availableOptions = $this->thankYouPage->getThankYouPageList();

        foreach ($availableOptions as $value) {
            $options[] = [
                'label' => "{$value['title']} - {$value['url_key']}",
                'value' => $value['thankyou_id'],
            ];
        }
        return $options;
    }

}
